unit Fonts;

interface

uses
    Windows, Messages, Classes, SysUtils, Graphics;

//=============================================================================
//
//  ꎞItHgCXg[NX
//
//=============================================================================
type
    TInstallFont = class
    private
        FFilePath: string;
        FInstalled : Boolean;
    public
        constructor	Create(const FilePath: string);
        destructor Destroy; override;
        function Install(): Boolean;
        procedure UnInstall();
    published
        property Installed: Boolean read FInstalled;
        property FilePath: string read FFilePath;
    end;

var
    MessageOut: TStrings = nil;

implementation

//=============================================================================
//
//  ꎞItHgCXg[NX
//
//=============================================================================

//-----------------------------------------------------------------------------
//  RXgN^
constructor TInstallFont.Create(const FilePath: string);
begin
    inherited Create;
    FFilePath := FilePath;
    FInstalled := False;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TInstallFont.Destroy;
begin
    if FInstalled then UnInstall();
    inherited Destroy;
end;

//-----------------------------------------------------------------------------
//  tHgCXg[
function TInstallFont.Install(): Boolean;
begin
    //  CXg[ĂȂꍇ
    if not FInstalled then
    begin
        //CXg[
        FInstalled := (AddFontResource(PChar(FFilePath)) <> 0);
        //̃AvP[Vɂʒm
        if FInstalled then SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);

        //  bZ[W\
        if (MessageOut <> nil) then
        begin
            if (FInstalled) then
            begin
                MessageOut.Add(Format(' OK  >> INSTALLED %s', [FFilePath]));
            end
            else
            begin
                MessageOut.Add(Format('FAIL >> NOT INSTALLED %s', [FFilePath]));
            end;
        end;
    end
    //  CXg[ς݂̏ꍇ
    else
    begin
        //  bZ[W\
        if (MessageOut <> nil) then
        begin
            MessageOut.Add(Format(' OK  >> ALREADY INSTALLED %s', [FFilePath]));
        end;
    end;
    Result := FInstalled;
end;

//-----------------------------------------------------------------------------
//  tHgACXg[
procedure TInstallFont.UnInstall();
begin
    //  CXg[ς݂̏ꍇ
    if FInstalled then
    begin
        //폜
        RemoveFontResource(PChar(FFilePath));
        //̃AvP[Vɂʒm
        SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
        //  ԃtOOFF
        FInstalled := False;
        //  bZ[W\
        if (MessageOut <> nil) then
        begin
            MessageOut.Add(Format(' OK  >> UNINSTALL %s', [FFilePath]));
        end;
    end;
end;

{
type
    TFontHacker = class
    private
        FWND: HWND;
        FOldFont: HFONT;
        FNewFont: HFONT;
    public
        constructor Create();
        destructor Destroy(); override;
        procedure Hack(const Target: HWND; NewFont: TFont);
        procedure Back();
    end;
}

{
constructor TFontHacker.Create();
begin
    //  nhĂ
    FWND     := INVALID_HANDLE_VALUE;
    FOldFont := INVALID_HANDLE_VALUE;
    FNewFont := INVALID_HANDLE_VALUE;
end;

destructor TFontHacker.Destroy();
begin
    Back();
end;

procedure TFontHacker.Hack(const Target: HWND; NewFont: TFont);
begin
    FWND := Target;

    //  VtHg
    FNewFont := NewFont.Handle;
    //FNewFont := GetStockObject(ANSI_FIXED_FONT);    

    //  Xݒ肳ĂtHg(Ŗ߂߂)ێĂ
    FOldFont := SendMessage(FWND, WM_GETFONT, 0, 0);

    //  ւ
    SendMessage(FWND, WM_SETFONT, FNewFont, MakeLong(1,0));
    //SendMessage(FTargetWND, WM_PAINT, 0, 0);
end;

procedure TFontHacker.Back();
begin
    //  ^[QbgEBhEłȂ(nbLOĂƂ݂Ȃ)
    if IsWindow(FWND) then
    begin
        //  ƂƂ̃tHgɖ߂
        SendMessage(FWND, WM_SETFONT, FOldFont, MakeLong(1,0));
        //SendMessage(FWND, WM_SETFONT, 0, MakeLong(1,0));

        FWND     := INVALID_HANDLE_VALUE;
        FOldFont := INVALID_HANDLE_VALUE;
        FNewFont := INVALID_HANDLE_VALUE;
    end;
end;
}
end.

